Qwt User's Guide: QwtInterval Class Reference

Qwt User's Guide 6.3.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
QwtInterval Class Reference

A class representing an interval. More...

`#include <qwt_interval.h>`

## Public Types
enum | BorderFlag { IncludeBorders = 0x00 , ExcludeMinimum = 0x01 , ExcludeMaximum = 0x02 , ExcludeBorders = ExcludeMinimum | ExcludeMaximum }
typedef QFlags< BorderFlag > | BorderFlags
| Border flags.

## Public Member Functions
| QwtInterval ()
| Default Constructor.
| QwtInterval (double minValue, double maxValue, BorderFlags=IncludeBorders)
void | setInterval (double minValue, double maxValue, BorderFlags=IncludeBorders)
QwtInterval | normalized () const
| Normalize the limits of the interval.
QwtInterval | inverted () const
QwtInterval | limited (double lowerBound, double upperBound) const
bool | operator== (const QwtInterval &) const
| Compare two intervals.
bool | operator!= (const QwtInterval &) const
| Compare two intervals.
void | setBorderFlags (BorderFlags)
BorderFlags | borderFlags () const
double | minValue () const
double | maxValue () const
double | width () const
| Return the width of an interval.
long double | widthL () const
| Return the width of an interval as long double.
void | setMinValue (double)
void | setMaxValue (double)
bool | contains (double value) const
bool | contains (const QwtInterval &) const
bool | intersects (const QwtInterval &) const
| Test if two intervals overlap.
QwtInterval | intersect (const QwtInterval &) const
| Intersect 2 intervals.
QwtInterval | unite (const QwtInterval &) const
| Unite 2 intervals.
QwtInterval | operator| (const QwtInterval &) const
QwtInterval | operator& (const QwtInterval &) const
| Intersection of two intervals.
QwtInterval & | operator|= (const QwtInterval &)
| Unite this interval with the given interval.
QwtInterval & | operator&= (const QwtInterval &)
| Intersect this interval with the given interval.
QwtInterval | extend (double value) const
| Extend the interval.
QwtInterval | operator| (double) const
QwtInterval & | operator|= (double)
bool | isValid () const
bool | isNull () const
void | invalidate ()
QwtInterval | symmetrize (double value) const

## Detailed Description

A class representing an interval.

The interval is represented by 2 doubles, the lower and the upper limit.

Definition at line 22 of file qwt_interval.h.

## Member Typedef Documentation

## ◆ BorderFlags

typedef QFlags<BorderFlag > QwtInterval::BorderFlags

Border flags.

An ORed combination of BorderFlag values.

Definition at line 45 of file qwt_interval.h.

## Member Enumeration Documentation

## ◆ BorderFlag

enum QwtInterval::BorderFlag

Flag indicating if a border is included or excluded

See also
  setBorderFlags(), borderFlags()

Enumerator
IncludeBorders | Min/Max values are inside the interval.
ExcludeMinimum | Min value is not included in the interval.
ExcludeMaximum | Max value is not included in the interval.
ExcludeBorders | Min/Max values are not included in the interval.

Definition at line 29 of file qwt_interval.h.

## Constructor & Destructor Documentation

## ◆ QwtInterval() [1/2]

QwtInterval::QwtInterval | ( |  | ) |
| inline

Default Constructor.

Creates an invalid interval [0.0, -1.0]

See also
  setInterval(), isValid()

Definition at line 112 of file qwt_interval.h.

## ◆ QwtInterval() [2/2]

QwtInterval::QwtInterval | ( | double | minValue,
|  | double | maxValue,
|  | BorderFlags | borderFlags = IncludeBorders )
| inline

Constructor

Build an interval with from min/max values

Parameters

  minValue | Minimum value
  maxValue | Maximum value
  borderFlags | Include/Exclude borders

Definition at line 128 of file qwt_interval.h.

## Member Function Documentation

## ◆ borderFlags()

QwtInterval::BorderFlags QwtInterval::borderFlags | ( |  | ) | const
| inline

Returns
  Border flags

See also
  setBorderFlags()

Definition at line 166 of file qwt_interval.h.

## ◆ contains() [1/2]

bool QwtInterval::contains | ( | const QwtInterval & | interval | ) | const

Test if an interval is inside an interval

Parameters

  interval | Interval

Returns
  true, if interval lies inside the boundaries

Definition at line 90 of file qwt_interval.cpp.

## ◆ contains() [2/2]

bool QwtInterval::contains | ( | double | value | ) | const

Test if a value is inside an interval

Parameters

  value | Value

Returns
  true, if value lies inside the boundaries

Definition at line 67 of file qwt_interval.cpp.

## ◆ extend()

QwtInterval QwtInterval::extend | ( | double | value | ) | const

Extend the interval.

If value is below minValue(), value becomes the lower limit. If value is above maxValue(), value becomes the upper limit.

extend() has no effect for invalid intervals

Parameters

  value | Value

Returns
  extended interval

See also
  isValid()

Definition at line 363 of file qwt_interval.cpp.

## ◆ intersect()

QwtInterval QwtInterval::intersect | ( | const QwtInterval & | other | ) | const

Intersect 2 intervals.

Parameters

  other | Interval to be intersect with

Returns
  Intersection

Definition at line 186 of file qwt_interval.cpp.

## ◆ intersects()

bool QwtInterval::intersects | ( | const QwtInterval & | other | ) | const

Test if two intervals overlap.

Parameters

  other | Interval

Returns
  True, when the intervals are intersecting

Definition at line 277 of file qwt_interval.cpp.

## ◆ invalidate()

void QwtInterval::invalidate | ( |  | ) |
| inline

Invalidate the interval

The limits are set to interval [0.0, -1.0]

See also
  isValid()

Definition at line 325 of file qwt_interval.h.

## ◆ inverted()

QwtInterval QwtInterval::inverted | ( |  | ) | const

Invert the limits of the interval

Returns
  Inverted interval

See also
  normalized()

Definition at line 48 of file qwt_interval.cpp.

## ◆ isNull()

bool QwtInterval::isNull | ( |  | ) | const
| inline

Returns
  true, if isValid() && (minValue() >= maxValue())

Definition at line 314 of file qwt_interval.h.

## ◆ isValid()

bool QwtInterval::isValid | ( |  | ) | const
| inline

A interval is valid when minValue() <= maxValue(). In case of QwtInterval::ExcludeBorders it is true when minValue() < maxValue()

Returns
  True, when the interval is valid

Definition at line 210 of file qwt_interval.h.

## ◆ limited()

QwtInterval QwtInterval::limited | ( | double | lowerBound,
|  | double | upperBound ) const

Limit the interval, keeping the border modes

Parameters

  lowerBound | Lower limit
  upperBound | Upper limit

Returns
  Limited interval

Definition at line 336 of file qwt_interval.cpp.

## ◆ maxValue()

double QwtInterval::maxValue | ( |  | ) | const
| inline

Returns
  Upper limit of the interval

Definition at line 198 of file qwt_interval.h.

## ◆ minValue()

double QwtInterval::minValue | ( |  | ) | const
| inline

Returns
  Lower limit of the interval

Definition at line 192 of file qwt_interval.h.

## ◆ normalized()

QwtInterval QwtInterval::normalized | ( |  | ) | const

Normalize the limits of the interval.

If maxValue() < minValue() the limits will be inverted.

Returns
  Normalized interval

See also
  isValid(), inverted()

Definition at line 29 of file qwt_interval.cpp.

## ◆ operator!=()

bool QwtInterval::operator!= | ( | const QwtInterval & | other | ) | const
| inline

Compare two intervals.

Parameters

  other | Interval to compare with

Returns
  True, when this and other are not equal

Definition at line 296 of file qwt_interval.h.

## ◆ operator&()

QwtInterval QwtInterval::operator& | ( | const QwtInterval & | other | ) | const
| inline

Intersection of two intervals.

Parameters

  other | Interval to intersect with

Returns
  Intersection of this and other

See also
  intersect()

Definition at line 258 of file qwt_interval.h.

## ◆ operator&=()

QwtInterval & QwtInterval::operator&= | ( | const QwtInterval & | other | ) |

Intersect this interval with the given interval.

Parameters

  other | Interval to be intersected with

Returns
  This interval

Definition at line 265 of file qwt_interval.cpp.

## ◆ operator==()

bool QwtInterval::operator== | ( | const QwtInterval & | other | ) | const
| inline

Compare two intervals.

Parameters

  other | Interval to compare with

Returns
  True, when this and other are equal

Definition at line 284 of file qwt_interval.h.

## ◆ operator|() [1/2]

QwtInterval QwtInterval::operator| | ( | const QwtInterval & | other | ) | const
| inline

Union of two intervals

Parameters

  other | Interval to unite with

Returns
  Union of this and other

See also
  unite()

Definition at line 272 of file qwt_interval.h.

## ◆ operator|() [2/2]

QwtInterval QwtInterval::operator| | ( | double | value | ) | const
| inline

Extend an interval

Parameters

  value | Value

Returns
  Extended interval

See also
  extend()

Definition at line 308 of file qwt_interval.h.

## ◆ operator|=() [1/2]

QwtInterval & QwtInterval::operator|= | ( | const QwtInterval & | other | ) |

Unite this interval with the given interval.

Parameters

  other | Interval to be united with

Returns
  This interval

Definition at line 253 of file qwt_interval.cpp.

## ◆ operator|=() [2/2]

QwtInterval & QwtInterval::operator|= | ( | double | value | ) |

Extend an interval

Parameters

  value | Value

Returns
  Reference of the extended interval

See also
  extend()

Definition at line 380 of file qwt_interval.cpp.

## ◆ setBorderFlags()

void QwtInterval::setBorderFlags | ( | BorderFlags | borderFlags | ) |
| inline

Change the border flags

Parameters

  borderFlags | Or'd BorderMode flags

See also
  borderFlags()

Definition at line 157 of file qwt_interval.h.

## ◆ setInterval()

void QwtInterval::setInterval | ( | double | minValue,
|  | double | maxValue,
|  | BorderFlags | borderFlags = IncludeBorders )
| inline

Assign the limits of the interval

Parameters

  minValue | Minimum value
  maxValue | Maximum value
  borderFlags | Include/Exclude borders

Definition at line 143 of file qwt_interval.h.

## ◆ setMaxValue()

void QwtInterval::setMaxValue | ( | double | maxValue | ) |
| inline

Assign the upper limit of the interval

Parameters

  maxValue | Maximum value

Definition at line 186 of file qwt_interval.h.

## ◆ setMinValue()

void QwtInterval::setMinValue | ( | double | minValue | ) |
| inline

Assign the lower limit of the interval

Parameters

  minValue | Minimum value

Definition at line 176 of file qwt_interval.h.

## ◆ symmetrize()

QwtInterval QwtInterval::symmetrize | ( | double | value | ) | const

Adjust the limit that is closer to value, so that value becomes the center of the interval.

Parameters

  value | Center

Returns
  Interval with value as center

Definition at line 317 of file qwt_interval.cpp.

## ◆ unite()

QwtInterval QwtInterval::unite | ( | const QwtInterval & | other | ) | const

Unite 2 intervals.

Definition at line 123 of file qwt_interval.cpp.

## ◆ width()

double QwtInterval::width | ( |  | ) | const
| inline

Return the width of an interval.

The width of invalid intervals is 0.0, otherwise the result is maxValue() - minValue().

Returns
  Interval width

See also
  isValid()

Definition at line 227 of file qwt_interval.h.

## ◆ widthL()

long double QwtInterval::widthL | ( |  | ) | const
| inline

Return the width of an interval as long double.

The width of invalid intervals is 0.0, otherwise the result is maxValue() - minValue().

Returns
  Interval width

See also
  isValid()

Definition at line 241 of file qwt_interval.h.